import type { ItemQuality, Item, InventoryItem } from '../types.d'

export const items: Item[] = [
  { name: 'Wooden Shovel', type: 'tool', icon: 'shovel', quality: 'wood' },
  { name: 'Wooden Pick Axe', type: 'tool', icon: 'pick', quality: 'wood' },
  { name: 'Wooden Sword', type: 'tool', icon: 'sword', quality: 'wood' },

  { name: 'Iron Shovel', type: 'tool', icon: 'shovel', quality: 'iron' },
  { name: 'Iron Pick Axe', type: 'tool', icon: 'pick', quality: 'iron' },
  { name: 'Iron Sword', type: 'tool', icon: 'sword', quality: 'iron' },

  { name: 'Diamond Shovel', type: 'tool', icon: 'shovel', quality: 'diamond' },
  { name: 'Diamond Pick Axe', type: 'tool', icon: 'pick', quality: 'diamond' },
  { name: 'Diamond Sword', type: 'tool', icon: 'sword', quality: 'diamond' },

  { name: 'Wooden Shovel', type: 'tool', icon: 'shovel', quality: 'wood' },
  { name: 'Wooden Pick Axe', type: 'tool', icon: 'pick', quality: 'wood' },
  { name: 'Wooden Sword', type: 'tool', icon: 'sword', quality: 'wood' },

  { name: 'leaves', type: 'block', icon: 'leaves', builds: 'treeLeaves' },
  { name: 'dirt', type: 'block', icon: 'dirt', builds: 'soil' },
  { name: 'wood', type: 'block', icon: 'wood', builds: 'treeTrunk' },
  { name: 'stone', type: 'block', icon: 'stone', builds: 'brickWall' },
  { name: 'gravel', type: 'block', icon: 'stone' }, // TODO

  { name: 'coal', type: 'ore', icon: 'ore_coal' },
  { name: 'iron', type: 'ore', icon: 'ore_iron' },
  { name: 'silver', type: 'ore', icon: 'ore_silver' },
  { name: 'gold', type: 'ore', icon: 'ore_gold' },
  { name: 'ruby', type: 'ore', icon: 'ore_ruby' },
  { name: 'diamond', type: 'ore', icon: 'ore_diamond' },
  { name: 'emerald', type: 'ore', icon: 'ore_emerald' },
]

export const damage: Record<ItemQuality, number> = {
  wood: 1,
  iron: 3,
  diamond: 5,
}

export function getItem(name: string, quality?: ItemQuality) {
  const item = items.find(i => i.name === name)
  if (item) {
    return {
      ...item,
      quality,
    }
  }
}

export function getItemClass(item: InventoryItem) {
  if (item.quality) return `${item.type}-${item.icon}-${item.quality}`
  return `${item.type}-${item.icon}`
}
